import React, { useEffect, useState } from 'react';
import { Form, Modal, Row, Col, Input, Select, notification } from 'antd';

const VideoModal = props => {
    const { callBackSubmit = () => { }, visible, onCancel, obj } = props;

    return (
        <Modal
            visible={visible}
            title={obj.Name}
            onCancel={onCancel}
            destroyOnClose
            width="1000px"
            maskClosable={false}
            footer={[]}
        >
            <div className="pp">
                < iframe style={{ border: 0, width: "100%", height: 630, }} src={window.location.origin + `/web4/video/indexAll.html?ID=${obj.EquipmentCode}&skipCheck=true&name=${obj.Name}&disk=${obj.RecorderName}&site=null`} />
            </div>
        </Modal>
    )
}
export default VideoModal